module Array_B
       (module Ix_B, Array, array, listArray, (!), bounds, indices, elems,
	assocs, accumArray, (//), accum, ixmap)
       where
import qualified Buddha as B
import Prelude_B
import Ix_B
import List_B ((\\))
v0 = B.ps "Array"
 
infixl 9 !, //
 
data (Ix a) => Array a b = MkArray (a, a) (B.F a b)
 
array :: (Ix a) => B.D ((a, a) -> [(a, b)] -> Array a b)
array v15 b ivs
  = case
      (and v15
	 ((>>=) v15 ivs
	    ((B.fu1
		(\ v1 ->
		   case v1 of
		      (i, _) -> (Prelude_B.return v15 ((inRange v15 b i)))
		      _ -> (Prelude_B.fail v15
			      "pattern match error: Array.hs (15,33)"))))))
      of
       True -> MkArray b
		 ((B.fu1
		     (\ j ->
			case
			  ((>>=) v15 ivs
			     ((B.fu1
				 (\ v2 ->
				    case v2 of
				       (i, v) -> ((>>) v15
						    (case ((==) v15 i j) of
							True -> [()]
							False -> [])
						    ((Prelude_B.return v15 v)))
				       _ -> (Prelude_B.fail v15
					       "pattern match error: Array.hs (17,45)")))))
			  of
			   [v] -> v
			   [] -> (error v15 "Array.!: undefined array element")
			   _ -> (error v15 "Array.!: multiply defined array element"))))
       False -> (error v15 "Array.array: out-of-range array association")
 
listArray :: (Ix a) => B.D ((a, a) -> [b] -> Array a b)
listArray v16 b vs
  = (array v16 b
       ((zipWith v16 ((B.fu2 (\ a b -> (a, b)))) ((range v16 b)) vs)))
 
(!) :: (Ix a) => B.D (Array a b -> a -> b)
(v18 ! v3) v17
  = case v3 of
       (MkArray _ f) -> (B.app f v17)
 
bounds :: (Ix a) => B.D (Array a b -> (a, a))
bounds v19 v4
  = case v4 of
       (MkArray b _) -> b
 
indices :: (Ix a) => B.D (Array a b -> [a])
indices v21 v20
  = ((.) v21 (B.fu1 (range v21)) (B.fu1 (bounds v21)) v20)
 
elems :: (Ix a) => B.D (Array a b -> [b])
elems v22 a
  = ((>>=) v22 ((indices v22 a))
       ((B.fu1 (\ i -> (Prelude_B.return v22 (((!) v22 a i)))))))
 
assocs :: (Ix a) => B.D (Array a b -> [(a, b)])
assocs v23 a
  = ((>>=) v23 ((indices v23 a))
       ((B.fu1 (\ i -> (Prelude_B.return v23 (i, ((!) v23 a i)))))))
 
(//) :: (Ix a) => B.D (Array a b -> [(a, b)] -> Array a b)
(v26 // a) new_ivs
  = (array v26 ((bounds v26 a)) (((++) v26 (old_ivs v26) new_ivs)))
  where
     old_ivs
       = \ v24 ->
	   ((>>=) v24 ((indices v24 a))
	      ((B.fu1
		  (\ i ->
		     ((>>) v24
			(case (notElem v24 i (new_is v24)) of
			    True -> [()]
			    False -> [])
			((Prelude_B.return v24 (i, ((!) v24 a i)))))))))
     new_is
       = \ v25 ->
	   ((>>=) v25 new_ivs
	      ((B.fu1
		  (\ v8 ->
		     case v8 of
			(i, _) -> (Prelude_B.return v25 i)
			_ -> (Prelude_B.fail v25
				"pattern match error: Array.hs (48,41)")))))
 
accum ::
      (Ix a) =>
	B.D (B.F b (B.F c b) -> Array a b -> [(a, c)] -> Array a b)
accum v29 f v27 v28
  = (foldl v29
       ((B.fu2
	   (\ a v30@(i, v) ->
	      ((//) v29 a [(i, (B.app (B.app f (((!) v29 a i))) v))]))))
       v27
       v28)
 
accumArray ::
	   (Ix a) =>
	     B.D (B.F b (B.F c b) -> b -> (a, a) -> [(a, c)] -> Array a b)
accumArray v32 f z b v31
  = (accum v32 f
       ((array v32 b
	   ((>>=) v32 ((range v32 b))
	      ((B.fu1 (\ i -> (Prelude_B.return v32 (i, z))))))))
       v31)
 
ixmap ::
      (Ix a, Ix b) => B.D ((a, a) -> B.F a b -> Array b c -> Array a c)
ixmap v33 b f a
  = (array v33 b
       ((>>=) v33 ((range v33 b))
	  ((B.fu1
	      (\ i -> (Prelude_B.return v33 (i, ((!) v33 a ((B.app f i))))))))))
 
instance (Ix a) => Functor (Array a) where
   fmap v34 fn v11
     = case v11 of
	  (MkArray b f) -> MkArray b ((B.fu1 ((.) v34 fn f)))
 
instance (Ix a, Eq b) => Eq (Array a b) where
   (v35 == a) a' = ((==) v35 ((assocs v35 a)) ((assocs v35 a')))
 
instance (Ix a, Ord b) => Ord (Array a b) where
   (v36 <= a) a' = ((<=) v36 ((assocs v36 a)) ((assocs v36 a')))
 
instance (Ix a, Show a, Show b) => Show (Array a b) where
   showsPrec v38 p a v37
     = (showParen v38 (((>) v38 p (arrPrec v38)))
	  ((B.fu1
	      ((.) v38 ((B.fu1 (showString v38 "array ")))
		 ((B.fu1
		     ((.) v38
			((B.fu1
			    (showsPrec v38 (((+) v38 (arrPrec v38) 1)) ((bounds v38 a)))))
			((B.fu1
			    ((.) v38 ((B.fu1 (showChar v38 ' ')))
			       ((B.fu1
				   (showsPrec v38 (((+) v38 (arrPrec v38) 1))
				      ((assocs v38 a))))))))))))))
	  v37)
 
instance (Ix a, Read a, Read b) => Read (Array a b) where
   readsPrec v40 p v39
     = (readParen v40 (((>) v40 p (arrPrec v40)))
	  ((B.fu1
	      (\ r ->
		 ((>>=) v40 ((lex v40 r))
		    ((B.fu1
			(\ v14 ->
			   case v14 of
			      ("array", s) -> ((>>=) v40
						 ((readsPrec v40 (((+) v40 (arrPrec v40) 1)) s))
						 ((B.fu1
						     (\ v13 ->
							case v13 of
							   (b, t) -> ((>>=) v40
									((readsPrec v40
									    (((+) v40 (arrPrec v40)
										1))
									    t))
									((B.fu1
									    (\ v12 ->
									       case v12 of
										  (as,
										   u) -> (Prelude_B.return
											    v40
											    ((array
												v40
												b
												as),
											     u))
										  _ -> (Prelude_B.fail
											  v40
											  "pattern match error: Array.hs (82,33)")))))
							   _ -> (Prelude_B.fail v40
								   "pattern match error: Array.hs (81,33)")))))
			      _ -> (Prelude_B.fail v40
				      "pattern match error: Array.hs (80,33)"))))))))
	  v39)
arrPrec = \ v41 -> 10